/* == Kernel Abstraction Layer ==
 It will grow-grow-grow... */

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 9, 0)
#define HAVE_COMPAT_IOCTL 1
#define HAVE_UNLOCKED_IOCTL 1
#endif

#ifndef IRQF_SHARED
# define IRQF_SHARED SA_SHIRQ
#endif //IRQF_SHARED

#ifndef IRQF_DISABLED
# define IRQF_DISABLED 0
#endif //IRQF_DISABLED

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)
#define QUASAR_DEVICE_CREATE(class, parent, devt, name) \
	device_create(class, parent, devt, NULL, "%s", name)
#else
#define QUASAR_DEVICE_CREATE(class, parent, devt, name) \
	device_create(class, parent, devt, "%s", name)
#endif //LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,19)
# define QUASAR_IRQ_HANDLER(a) static irqreturn_t a(int irq_num, void * pr_data)
# define QUASAR_PARENT(tmp_dev) (NULL)
#else
# define QUASAR_IRQ_HANDLER(a) static irqreturn_t a(int irq_num, void * pr_data, struct pt_regs * amba)
# define QUASAR_PARENT(tmp_dev) get_device(&tmp_dev->pci_device->dev)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
#warning Linux < 2.6.18 not supported by Quasar driver !
#endif

